'use strict';

//Do it
getData();

function getData() {
    
    console.log('Getting Data...');

    //Clear existing display
    document.getElementById("content").innerHTML = "";

    //Set updated date/time
    document.getElementById("updated").innerHTML = new moment().format("dddd, MMMM Do YYYY, h:mm:ss a");

    //get the URL to the data - which is the same url as this file sans '/pretty/' or sans '/pretty' or sans '/pretty/index.html' depending on how accessed
    //the url params are still passed so the key still works
    var url = window.location.href.replace('/pretty/', '');
    url = url.replace('/pretty', '');
    url = url.replace('/pretty/index.html', '');
    fetch(url)
        .then((res) => {

            return res.json().then(json => {
                if (!res.ok) throw new Error(json.error.message);

                // Copy the template into content and populate it
                json.forEach(item => {
                    var clone = document.getElementById("item-template").cloneNode(true);

                    //convert values which are dates or json
                    var date = new moment(item.value, [
                        moment.ISO_8601,
                        "DD-MM-YYYY",
                        "MM-DD-YYYY",
                        "YYYY-MM-DD",
                        moment.HTML5_FMT.DATETIME_LOCAL,
                        moment.HTML5_FMT.DATETIME_LOCAL_SECONDS,
                        moment.HTML5_FMT.DATETIME_LOCAL_MS
                    ], true);//The true argument is there so the Moment won't try to parse the input if it doesn't exactly conform to one of the formats provided
                    if (date.isValid()) item.value = date.format("dddd, MMMM Do YYYY, h:mm:ss a");
                    if (typeof item.value === 'object') item.value = JSON.stringify(item.value, null, 2);//stringify and indent

                    clone.getElementsByClassName('item-description')[0].innerHTML = item.description;
                    clone.getElementsByClassName('item-value')[0].innerHTML = item.value;
                    document.getElementById("content").appendChild(clone);
                });

                //need to decode value if json or convert to date if date

                console.log('Output: ', json);

            });

        }).catch(error => {

            // Copy the template into content and populate it
            var clone = document.getElementById("error-template").cloneNode(true);
            clone.getElementsByClassName('error-message')[0].innerHTML = error.message;
            document.getElementById("content").appendChild(clone);

            console.error(error);

        });
}
